
const Router = require('koa-router');
const Db  = require('./dbapi')
const path =require('path')

let obj ={}

obj.create =function(dbhome,prefix ='/api/dbop'){
    let r ={}
    r.router = new Router({ prefix })
    r.getdb =function (dbname) {
        //console.log(dbname,dbhome)
        let p1 = path.join(dbhome,dbname+'.js')
        try {
           let db = require(p1)
           return db
        } catch(e){
           console.log(e)
           return null
        }
    };
    r.router.post('/:db/:func', async (ctx, next) => {
      //console.log(ctx.params)
      //console.log(ctx.request.body)

      let p1 = path.join(dbhome,ctx.params.db+'.js')
      try {
         let db = require(p1)
         let op = Object.assign({},ctx.query,ctx.request.body)
         let r = await db[ctx.params.func](op)
         //console.log('err0',JSON.stringify(r))
         if (JSON.stringify(r)=='{}') {
            r ={data:[],total:0,code:-1}
         }
         ctx.body =r
         
      } catch(e){
      
         console.log(e)
         ctx.body ={data :[],total:0,code :-1}
      }
  });
    r.router.get('/:db/:func', async (ctx, next) => {  
      let p1 = path.join(dbhome,ctx.params.db+'.js')
      try {
         let db = require(p1)
         let op = ctx.request.query
         //console.log(op,ctx.params)
         let r = await db[ctx.params.func](op)
         //console.log('err0',JSON.stringify(r))
         if (JSON.stringify(r)=='{}') {
            r ={data:[],total:0,code:-1}
         }
         ctx.body = r
  
      } catch(e){
         console.log(e)
         ctx.body = e
      }
  
  });  
    r.router.get('/:db/:func', async (ctx, next) => {  
      let p1 = path.join(dbhome,ctx.params.db+'.js')
      try {
         let db = require(p1)
         let op = ctx.request.query
         //console.log(op,ctx.params)
         let r = await db[ctx.params.func](op)
         //console.log('err0',JSON.stringify(r))
         if (JSON.stringify(r)=='{}') {
            r ={data:[],total:0,code:-1}
         }
         ctx.body = r
  
      } catch(e){
         console.log(e)
         ctx.body = e
      }
  
  });   
  r.router.get('/:db/:schema/:tname/:func', async (ctx, next) => {  
        let p1 = path.join(dbhome,ctx.params.db+'.js')
        try {
           let db = require(p1)
           //console.log(op,ctx.params)
           let op = Object.assign({},ctx.query,{schema:ctx.params.schema,tname:ctx.params.tname})
           let r = await db[ctx.params.func](op)
           console.log(op)
           //console.log('err0',JSON.stringify(r))
           if (JSON.stringify(r)=='{}') {
              r ={data:[],total:0,code:-1}
           }
           ctx.body = r
    
        } catch(e){
           console.log(e)
           ctx.body = e
        }
    
    }); 
    r.router.post('/:db/:schema/:tname/:func', async (ctx, next) => {
      //console.log(ctx.params)
      //console.log(ctx.request.body)
      let p1 = path.join(dbhome,ctx.params.db+'.js')
      try {
         let db = require(p1)
         let op = Object.assign({},ctx.query,ctx.request.body,{schema:ctx.params.schema,tname:ctx.params.tname})

         let r = await db[ctx.params.func](op)
         //console.log('err0',JSON.stringify(r))
         if (JSON.stringify(r)=='{}') {
            r ={data:[],total:0,code:-1}
         }
         ctx.body =r
         
      } catch(e){
      
         console.log(e)
         ctx.body ={data :[],total:0,code :-1}
      }
    });       
    return r
}

obj.Db =Db

module.exports = obj
