const app = new (require('koa'))();
const koaBody = require("koa-body")
const cors = require('@koa/cors');
const art = require('art-template');

app.use(cors());
app.use(koaBody({
    formLimit: '20MB',
    jsonLimit: '20MB',
    textLimit: '20MB',
    multipart: true,
    includeUnparsed:true,
    formidable: {
        uploadDir:'d:/uploads',
        keepExtensions: true,
        maxFileSize: 200 * 1024 * 1024    // 设置上传文件大小最大限制，默认2M
    },
}));

const pgdb = require('./index').create(__dirname +'/dbhome' ,'/api/dbop')
//const pgdb = require('bigbaby-pg').create(__dirname +'/dbhome' ,'/api/dbop')
let db =pgdb.getdb('sysdb')
let db2 =pgdb.getdb('sysdb2')
 async function f1() {
    let r2
    //let r = await db.tableSelect({tname:'test'})
    // r2 = await db.tableInsert({tname:'test',data:[{dt0:'2012-01-01T12:00:00Z'},{dt0:'2012-01-01T12:00:00Z'}],log:1})
    // console.log(r,JSON.parse(JSON.stringify(r))
    //r2 = await db.PKDel({tname:'t4'})
    //r2 =await db.PKAdd({tname:'t4',cols:['t1','s1']})
    //r2 =await db.tableDel({tname:'t4'})
    //r2 =await db.tableDel({tname:'t4'})
    //r2 =await db.tableCopy({tname:'t4',newname:'t6'})
    // r2 =await db.tableCopy({tname:'t1',newname:'t3',schema:'tt2'})
    // r2 =await db.columnGet({tname:'t1'})

    // let op={tname:"t1",cname: 'ss6',
    // ccomment: 'aaabb',
    // cnull: 'NO',
    // ctype: 'numeric',
    // clen: 18,
    // cscale: 2,
    // cdef: "0"}

    let r = await db.sqlInsert({tname:'sys_sql',data:[{sql:'select * from sys_user',name:'test003-36',dbname:''}]})
    console.log(r)

    //r2 = await db.columnSet(op)
    //r2 = await db.tableDel({tname:'t10'})

    //r2 = await db.tableCreate({tname:'t117'})
    

   // r2 =await db.tableCopy({tname:'t4',newname:'t6'})

    //console.log(r2.result.rows)
     //let r = await db.createtypewithschema({tname:'test3',cols:[{name:'aa',type:'Number'},{name:'bb',type:'Number'},{name:'cc',type:'Number'}]})
    // console.log(r)
    //let r = await db.createformdatatable()
    //let r0 = await db.formInsert({tname:'test2',data:[{aa:1,bb:2,cc:3},{aa:2,bb:3,cc:4}]})
    //let r = await db.formUpdate({tname:'abcd',data:[{a:55,__id:2}]})
    //let r = await db.formDelete({tname:'abcd',data:[{__id:1}]})
    //let r = await db.formGet({tname:'abcd',__id:2})
    //let r1 = await db.formSelect({tname:'abcd',__id:2})
    
    //r2 = await db.formInsert({tname:'test3',data:[{aa:1,bb:2,cc:3},{aa:2,bb:3,cc:4}]})
    //r2 = await db.formSelect({tname:'test3',page:1,pageSize:5,filter:{logic:' and ',filters:[{field:"__id",operator:'gt',value:"1"},{field:"__id",operator:'lt',value:"400"}]},})
    // r2 = await db.savesqlfile({tname:'test03',template:'select * from _tr_dbop_log where id >{{id}}',param:{id:1}})
    // r2 = await db.savesqlfile({tname:'test02',template:'select * from [[test03]] b',param:{id:1}})
    // r2 = await db.savesqlfile({tname:'test01',template:'select * from [[test02]] a',param:{id:1}})
    //r2 = await db.savesqlfile({tname:'test03',template:'select * from _tr_dbop_log',param:{id:1}})
    //r2 = db.listsqlfiles()
    //r2 = await db.getsqlfile({tname:'test01'})
    
    //r2 = await db.sqlSelect({tname:'test01',param:{id:10}})
    //console.log(r2)

    // let ss=' my is {{aaa}} {{ccc.aaa}}' 
    // let data ={aaa:123,}

    // let f= art.compile(ss)
    // r2 = f(data,{bail:false,onerror:function(e){
    //     console.log('ccc')
    //     return 0
    // }})
    // console.log(r2)
}
 f1()
app.use(pgdb.router.routes())

app.listen(50003,()=>{
    console.log("server is ok")
})