let req =require('request-promise')

let f ={}

f.f1 =async  function(){
    let op = {url:'http://127.0.0.1:8800/api/dbop/sysdb/savesqlfile',
              method:'POST',
              body:{tname:'test3',template:'select * from sys_users where id ={{id}}',param:{id:1}},
              json:true,
    }
    let r = await req(op)
    console.log(r)

}

f.listsqlfiles =async  function(){
    let op = {url:'http://127.0.0.1:8800/api/dbop/sysdb/listsqlfiles',
              method:'GET',
    }
    let r = await req(op)
    console.log(r)

}

f.f2 =async  function(){
    let op = {url:'http://127.0.0.1:8800/api/dbop/sysdb/sqlSelect',
              method:'POST',
              body:{tname:'test3',param:{id:1},},
              json:true,
    }
    let r = await req(op)
    console.log(r)

}

f.f3 =async  function(){
    let op = {url:'http://127.0.0.1:8800/api/dbop/sysdb/tableInsert',
              method:'POST',
              body:{tname:'sys_users',data:[{name:'bvbbb'},{name:"dasdfe"}],case:'lower'},
              json:true,
    }
    let r = await req(op)
    console.log(r)

}

f.del =async  function(){
    let op = {url:'http://127.0.0.1:8800/api/dbop/sysdb/tableDelete',
              method:'POST',
              body:{tname:'sys_users',data:[{id:4},{id:5}],case:'lower'},
              json:true,
    }
    let r = await req(op)
    console.log(r)

}

f.update =async  function(){
    let op = {url:'http://127.0.0.1:8800/api/dbop/sysdb/tableUpdate',
              method:'POST',
              body:{tname:'sys_users',data:[{id:1,'name':'up3'},{id:2,name:'up4'}],case:'lower'},
              json:true,
    }
    let r = await req(op)
    console.log(r)

}

f.upsert =async  function(){
    let op = {url:'http://127.0.0.1:8800/api/dbop/sysdb/tableUpsert',
              method:'POST',
              body:{tname:'sys_users',data:[{id:1,'name':'up31'},{id:2,name:'up41'}],case:'lower'},
              json:true,
    }
    let r = await req(op)
    console.log(r)
}


f.makeschema =async  function(){
    let op = {url:'http://127.0.0.1:8800/api/dbop/sysdb/makeTableSchema',
              method:'POST',
              body:{tname:'sys_menus'},
              json:true,
    }
    let r = await req(op)
    console.log(r)
}


/*
operator 
   startwith,endswith,contains,isnull,isempty,isnotnull,isnotempty,eq,neq,lt（效应）,lte,gt(大于),gte
*/
f.tableselect =async  function(){
    let op = {url:'http://127.0.0.1:8800/api/dbop/sysdb/tableSelect',
              method:'POST',
              body:{tname:'_tr_dbop_log',
                    pageSize:2,page:1,
                    sort:[{field:'id',dir:'desc'}],
                    filter:{logic:' and ',filters:[{field:"id",operator:'gt',value:"1"},{field:"id",operator:'lt',value:"10"}]},
               },
              json:true,
    }
    let r = await req(op)
    console.log(r)
}

/*
operator 
   startwith,endswith,contains,isnull,isempty,isnotnull,isnotempty,eq,neq,lt（效应）,lte,gt(大于),gte
*/

f.sqlselect =async  function(){
    let op = {url:'http://127.0.0.1:1234/api/dbop/sysdb/sqlSelect',
              method:'POST',
              body:{tname:'getdboplogv1',
                    param:{id1:2,id2:5},
                    pageSize:3,page:1,
                    sort:[{field:'id',dir:'desc'}],
                    filter:{logic:' and ',filters:[{field:"tname",operator:'eq',value:"sys_users"}]},
               },
              json:true,
    }
    let r = await req(op)
    console.log(r)
}

let args = process.argv.splice(2);

f[args[0]]()