const app = new (require('koa'))();
const koaBody = require("koa-body")
app.use(koaBody({
    formLimit: '20MB',
    jsonLimit: '20MB',
    textLimit: '20MB',
    multipart: true,
    includeUnparsed:true,
    formidable: {
        uploadDir:'d:/uploads',
        keepExtensions: true,
        maxFileSize: 200 * 1024 * 1024    // 设置上传文件大小最大限制，默认2M
    },
}));

const pgdb = require('../index').create(__dirname +'/dbhome' ,'/api/dbop')
let db =pgdb.getdb('sysdb')
console.log(db)
async function f1() {
    let r = await db.sqlInsert({tname:'sys_sql',data:[{template:'select * from sys_user',name:'test003-1'}]})
    console.log(r)
}
f1()
app.use(pgdb.router.routes())

app.listen(8800)