const qs = require('qs');
var fs = require('fs');
var path = require('path');

let utils = {}
utils.getjsonschema = function (json) {
    //console.log(json)
    let schema = {}
    let ctype
    let cobj
    function gettype(value) {
        if (!value && typeof (value) != "undefined" && value != 0) { return 'string' }
        if (typeof (value) == "object") {
            //if (value) { return 'string'}
            if (value instanceof Array) { return 'array' } else { return 'object' }
        }
        else {
            return typeof (value)
        }
    };

    function TraversalObject(obj) {
        ctype = gettype(obj)
        // console.log("json----------")
        //console.log(JSON.stringify(obj))
        //console.log(ctype)

        switch (ctype) {
            case 'array':
                if (!schema.type) {
                    // console.log('schema')
                    schema = { type: 'array', items: {}, title: 'root' }
                    cobj = schema
                } else {
                    if (cobj.items) {
                        cobj.items = { type: 'array', items: {} }
                        cobj = cobj.items
                    } else {
                        cobj.properties = { type: 'array', items: {} }
                        cobj = cobj.items
                    }

                }
                //递归数组
                //console.log(schema)
                if (obj[0]) {
                    TraversalObject(obj[0])
                    return
                }
                break;
            case 'object':
                if (!schema.type) {
                    schema = { type: 'object', properties: {}, title: 'root' }
                    cobj = schema
                }
                else {
                    if (cobj.items) {
                        cobj.items = { type: 'object', properties: {} }
                        cobj = cobj.items
                    } else {
                        cobj.properties = { type: 'object', properties: {} }
                        cobj = cobj.items

                    }
                }
                break;
            default:
        }
        for (let a in obj) {
            //console.log(a)
            //console.log(JSON.stringify(schema))

            let atype = gettype(obj[a]);
            //console.log(schema)
            switch (atype) {
                case 'object':
                    cobj.properties[a] = { type: 'object', title: a, properties: {} }
                    let cobj1 = cobj;
                    cobj = cobj.properties[a];
                    TraversalObject(obj[a]); //递归遍历
                    cobj = cobj1;
                    break;
                case 'array':
                    //console.log(a + "=" + JSON.stringify(obj[a]) + ',' + gettype(obj[a]));//值就显示
                    if (obj[a].length > 0) {
                        cobj.properties[a] = { type: 'array', title: a, items: {} }
                        let cobj1 = cobj
                        cobj = cobj.properties[a]
                        TraversalObject(obj[a][0])
                        cobj = cobj1
                        //递归遍历
                    } else {
                        cobj.properties[a] = { type: 'string', title: a, }
                        //console.log(a + "=" + obj[a] + ',' + atype);//值就显示

                    }
                    break;
                default:
                    cobj.properties[a] = { type: gettype(obj[a]), title: a }
                // console.log(a + "=" + obj[a] + ',' + atype);//值就显示
            }
        }
    };

    TraversalObject(json);
    //console.log(schema);
    return schema;
}

utils.getip = async (ctx, next) => {
    let req = ctx.req;
    let ip = req.headers['x-forwarded-for'] ||
        req.connection.remoteAddress ||
        req.socket.remoteAddress ||
        req.connection.socket.remoteAddress;
    let p = ip.lastIndexOf(':');
    if (p > 0) { ip = ip.substring(p + 1) }
    //console.log(ip);
    //console.log(ctx.method, ctx.url);
    // console.log(ctx.request.body);
    ctx.ipaddr = ip;
    //if (whitelist(ip)) {
    //  if (! ctx.session.user) { ctx.session.user =  whitelist(ip)}
    //}
    await next();
}
utils.checksession = async (ctx, next) => {
    if (ctx.session.user) {
        //ctx.session.refresh();
        //ctx.body=ctx.session
        await next()
    } else {
        //console.log(ctx.session) 
        //ctx.body='not login'
        //ctx.session.user ={name:'aabc'}
        //ctx.redirect('/auth/login')
        //ctx.status = 404;
        ctx.body = {
            code: -3,
            msg: '页面找不到',
        }
    }
}

utils.parsequery = async (ctx, next) => {
    ctx.qs = qs.parse(ctx.querystring);
    //console.log(ctx.qs);
    if (ctx.qs.param) {
        // console.log(ctx.qs.param);
    }
    await next();
}

utils.createArDatacnf = async function (p) {
    let ar = {}
    reportParameter = {
        Type: "reportparameter",
        DataType: "String",
        DefaultValue: '',//{Values: [datahost+'/rp/testdata/'+sql]},
        Hidden: true,
        Multiline: true,
        Name: "dataurl",
        Prompt: "dataurl",
        UsedInQuery: "True"
    }
    dataSource = {
        Transaction: false,
        ConnectionProperties: {
            DataProvider: "JSON",
            ConnectString: '',// "=\"jsondoc=\"+ Parameters!dataurl.Value+\";schemadoc="+datahost+"/rp/schema/t2\"",
            IntegratedSecurity: false
        },
        Name: "DataSource1"
    }

    dataSet = {
        Fields: [],
        Query: {
            DataSourceName: "DataSource1",
            CommandType: "Text",
            CommandText: "$.data[*]",
            Timeout: 0
        },
        CaseSensitivity: "Auto",
        AccentSensitivity: "Auto",
        KanatypeSensitivity: "Auto",
        WidthSensitivity: "Auto",
        Name: "DataSet1"
    }

    ar.ReportParameters = []
    ar.DataSets = []
    ar.DataSources = []
    for (let i = 0; i < p.length; i++) {
        try {
            let e = p[i]
            if (!e.datahost) { e.datahost = cnf.datahost }
            //console.log(e)
            let r = await db.executeSqlWithData("select schema as out from sys_sql  where name=$1", [e.sql]);
            //console.log(r)
            if (r.code == 0) {
                reportParameter.Name = 'dataurl' + i
                reportParameter.Prompt = 'dataurl' + i
                reportParameter.DefaultValue = { Values: [e.datahost + '/rp/testdata/' + e.sql] }
                ar.ReportParameters.push(JSON.parse(JSON.stringify(reportParameter)))
                dataSource.Name = 'DataSource' + i
                dataSource.ConnectionProperties.ConnectString = '="jsondoc="+ Parameters!dataurl' + i + '.Value+";schemadoc=' + e.datahost + '/rp/schema/' + e.sql + '"'
                ar.DataSources.push(JSON.parse(JSON.stringify(dataSource)))
                let fields = []
                for (let i in r.data.properties.data.items.properties) {
                    fields.push({ Name: r.data.properties.data.items.properties[i].title, Datafield: i })
                }
                dataSet.Fields = fields
                dataSet.Query.DataSourceName = 'DataSource' + i
                dataSet.Name = 'DateSet' + i
                ar.DataSets.push(JSON.parse(JSON.stringify(dataSet)))

            }
        } catch (e) {
            console.log(e)
            return null
        }
    }
    //console.log(ar)
    return ar;
}

utils.require2 = function (p) {
    try {
        //console.log(require.resolve(p))
        delete require.cache[require.resolve(p)];
        let app = require(p);
        return app
    } catch(e) {
        console.log(e)
        return null
    }
}

utils.isArray = function (o) {
    return Object.prototype.toString.call(o) === '[object Array]';
}


utils.upperJSONKey = function (O) {
    if (typeof (O) != 'object') {
        console.log(typeof (O))
        return O
    }
    if (this.isArray(O)) {

        let r1 = []
        for (const row of O) {
            if (typeof (row) == 'object') {
                let r0 = {}
                for (var key in row) {
                    r0[key.toUpperCase()] = row[key];
                }
                r1.push(r0)
            } else {
                r1.push(row)
            }
        }
        return r1
    } else {
        let r0 = {}
        for (var key in O) {
            r0[key.toUpperCase()] = O[key];
        }
        return r0
    }
}

utils.lowerJSONKey = function (O) {
    if (typeof (O) != 'object') { return O }
    if (this.isArray(O)) {
        let r1 = []
        for (const row of O) {
            if (typeof (row) == 'object') {
                let r0 = {}
                for (var key in row) {
                    r0[key.toLowerCase()] = row[key];
                }
                r1.push(r0)
            } else {
                r1.push(row)
            }
        }
        return r1
    } else {
        let r0 = {}
        for (var key in O) {
            r0[key.toLowerCase()] = O[key];
        }
        return r0
    }
}
utils.getFileList = function (dir) {
    try {
        let alen = dir.length
        function readFileList(dir, filesList = []) {
            const files = fs.readdirSync(dir);
            //console.log(files);
            files.forEach((item, index) => {
                //console.log(item)
                var fullPath = path.join(dir, item);
                const stat = fs.statSync(fullPath);
                if (stat.isDirectory()) {
                    readFileList(path.join(dir, item), filesList); //递归读取文件
                } else {
                    //console.log(item)
                    let s = fullPath.substr(alen + 1)
                    filesList.push({tname: s.substr(0,s.length - 3),fullpath:fullPath});
                }
            });
            return filesList;
        }
        return readFileList(dir)
    } catch (err) {
        console.log(err)
        return []
    }

}
utils.tempProc =function(tmp,file)  {

    let f = path.parse(file)
    
    let a =tmp.match(/\[\[.*?\]\]/g)
    let b =tmp.split(/\[\[.*?\]\]/)
    let c=a.map(i=>{return i.substr(2,i.length -4)})
    
    c = c.map(i=>{
        let sql =require( path.join(f.dir,i,'.js'))
        return sql.template0
        //return 'select * from aa'
    })
    let s ='' 
    for (let i=0;i<b.length ;i++) {
       if (i < c.length  ) {
         s = s+ b[i] +'(' + c[i]+')' 
       } else {
         s = s + b[i]
       }
    }
    return s

} 
module.exports = utils